<?php
/**
 * @package     Joomla - > Site and Administrator payment info
 * @subpackage  com_Hikashop
 * @copyright   Copyright (C) 2017 Open Source Matters, Inc. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 */
defined('_JEXEC') or die('Restricted access');

if (!class_exists ('checkHack')){
    require_once JPATH_SITE . '/plugins/hikashoppayment/aqayepardakht/aqayepardakht_inputcheck.php';
}

class plgHikashoppaymentaqayepardakht extends hikashopPaymentPlugin {
    var $accepted_currencies = array( "IRR" );
    var $multiple = true;
    var $name = 'aqayepardakht';
    var $pluginConfig = array(
        'merchant_id' => array("شناسه درگاه",'input')
    );

    function __construct(&$subject, $config) {
        return parent::__construct($subject, $config);
    }

    function onBeforeOrderCreate(&$order,&$do){
        if(parent::onBeforeOrderCreate($order, $do) === true)
            return true;

        if (empty($this->payment_params->merchant_id)) {
            $this->app->enqueueMessage('لطفا تنظیمات پلاگین دخلستان را وارد نمایید','error');
            $do = false;
        }
    }

    function onAfterOrderConfirm(&$order,&$methods,$method_id) {
        parent::onAfterOrderConfirm($order,$methods,$method_id);
        $notify_url = HIKASHOP_LIVE.'index.php?option=com_hikashop&ctrl=checkout&task=notify&notif_payment='.$this->name.'&tmpl=component&lang='.$this->locale . $this->url_itemid.'&orderid='.$order->order_id;
        $return_url = HIKASHOP_LIVE.'index.php?option=com_hikashop&ctrl=checkout&task=after_end&order_id='.$order->order_id . $this->url_itemid;
        $cancel_url = HIKASHOP_LIVE.'index.php?option=com_hikashop&ctrl=order&task=cancel_order&order_id='.$order->order_id . $this->url_itemid;

        $config = JFactory::getConfig();
        $app	= JFactory::getApplication();
        $Amount =($order->cart->full_total->prices[0]->price_value_with_tax)/10; // Toman
        $Description = 'خرید محصول از فروشگاه   '. $config->get( 'sitename' );
        $Email = '';
        $Mobile = '';
        $CallbackURL =  $notify_url;

        try {


            $f = array(
                'amount' => $Amount,
                'pin' => $this->payment_params->merchant_id,
                'callback' => $CallbackURL,
                'bank' => 'mellat',
                'description' => $Description
            );

            $f_ = '';
            foreach($f as $k=>$v)
                $f_ .= $k . '=' . urlencode($v) . '&';

            rtrim($f_, '&');

            $ch = curl_init();
            curl_setopt($ch,CURLOPT_URL, "https://panel.aqayepardakht.ir/api/create/");
            curl_setopt($ch,CURLOPT_POST, count($f));
            curl_setopt($ch,CURLOPT_POSTFIELDS, $f_);
            curl_setopt($ch,CURLOPT_RETURNTRANSFER, true);
            $result = curl_exec($ch);
            curl_close($ch);

            if(strlen($result) > 5) {
                header("Location: https://panel.aqayepardakht.ir/startpay/{$result}");
                exit;
            } else {
                $msg= 'مشکلی در اتصال به بانک مشاهده شد لطفا با مدیر سایت در تماس باشید. 2 ';
                $app	= JFactory::getApplication();
                $link = $cancel_url;
                $app->redirect($link, '<h2>'.$msg.'</h2>', $msgType='Error');
            }

        }
        catch(\SoapFault $e) {
            $msg= 'مشکلی در اتصال به بانک مشاهده شد لطفا با مدیر سایت در تماس باشید. 1 ';
            $app	= JFactory::getApplication();
            $link = $cancel_url;
            $app->redirect($link, '<h2>'.$msg.'</h2>', $msgType='Error');
        }
    }

    function onPaymentNotification(&$statuses)	{
        $app	= JFactory::getApplication();
        $jinput = $app->input;
        $orderId = $jinput->get->get('orderid', '0', 'INT');
        if($orderId != null){
            $Order = $this->getOrder($orderId);
            $this->loadPaymentParams($Order);
            // $mobile = $this->getInfo($Order->order_user_id);
            $return_url = HIKASHOP_LIVE.'index.php?option=com_hikashop&ctrl=checkout&task=after_end&order_id='.$orderId.$this->url_itemid;
            $cancel_url = HIKASHOP_LIVE.'index.php?option=com_hikashop&ctrl=order&task=cancel_order&order_id='.$orderId.$this->url_itemid;
            $history = new stdClass();
            $history->amount = round($Order->order_full_price,5)/10;
            //------------------------------------------------------

            if ($_POST['transid']) {
                $transid = $_POST['transid'];
                try {

                    $f = array(
                        'amount' => $history->amount,
                        'pin' => $this->payment_params->merchant_id,
                        'transid' => $transid,
                    );

                    $f_ = '';
                    foreach($f as $k=>$v)
                        $f_ .= $k . '=' . urlencode($v) . '&';

                    rtrim($f_, '&');

                    $ch = curl_init();
                    curl_setopt($ch,CURLOPT_URL, "https://panel.aqayepardakht.ir/api/verify/");
                    curl_setopt($ch,CURLOPT_POST, count($f));
                    curl_setopt($ch,CURLOPT_POSTFIELDS, $f_);
                    curl_setopt($ch,CURLOPT_RETURNTRANSFER, true);
                    $res = curl_exec($ch);
                    curl_close($ch);



                    if ($res == 1) {
                        $history->notified = 1;
                        $history->data = 'شماره پیگیری '. $transid;
                        $this->modifyOrder($orderId, 'confirmed', $history, true);
                        $app->redirect($return_url, '<h2>'.$msg.'</h2>'.'<h3>'. $transid .'شماره پیگری ' .'</h3>' , $msgType='Message');

                    }
                    else {
                        $msg= 'پرداخت انجام نشد . 3';
                        $this->modifyOrder($orderId, 'cancelled', false, false);
                        $app->redirect($cancel_url, '<h2>'.$msg.'</h2>' , $msgType='Error');
                    }
                }
                catch(\SoapFault $e) {
                    $msg= 'پرداخت انجام نشد . 2';
                    $this->modifyOrder($orderId, 'cancelled', false, false);
                    $app->redirect($cancel_url, '<h2>'.$msg.'</h2>' , $msgType='Error');
                }
            }
            else {
                $msg= 'پرداخت انجام نشد . 1';
                $this->modifyOrder($orderId, 'cancelled', false, false);
                $app->redirect($cancel_url, '<h2>'.$msg.'</h2>' , $msgType='Error');
            }

        }
        else {
            $msg= 'پرداخت انجام نشد . 4';
            $this->modifyOrder($orderId, 'cancelled', false, false);
            $app->redirect($cancel_url, '<h2>'.$msg.'</h2>' , $msgType='Error');
        }
    }


    public function getInfo ($id){
        $db = JFactory::getDbo();
        $query = $db->getQuery(true);
        $query->select('address_telephone');
        $query->from($db->qn('#__hikashop_address'));
        $query->where($db->qn('address_user_id') .  '=' . $db->q(intval($id)));
        $db->setQuery((string)$query);
        $result = $db->Loadresult();
        return $result;
    }
}
